ArgumentException ArgumentException ArgumentException ArgumentException Class

Definice

Výjimka, která je vyvolána, pokud jeden z argumentů poskytnutých metodě není platný.The exception that is thrown when one of the arguments provided to a method is not valid.

public ref class ArgumentException : SystemException
[System.Runtime.InteropServices.ComVisible(true)]
[System.Serializable]
public class ArgumentException : SystemException
type ArgumentException = class
    inherit SystemException
    interface ISerializable
Public Class ArgumentException
Inherits SystemException
Dědičnost
Odvozené
Atributy
Implementuje

Příklady

Následující příklad ukazuje, jak vyvolat a zachytit ArgumentException.The following example demonstrates how to throw and catch an ArgumentException. Používá rozhraní ArgumentException. GetType (). Vlastnost Name pro zobrazení názvu objektu výjimky a také Message vlastnost používá k zobrazení textu zprávy o výjimce.It uses the ArgumentException.GetType().Name property to display the name of the exception object, and also uses the Message property to display the text of the exception message.

using namespace System;

static int DivideByTwo(int num) 
{
    // If num is an odd number, throw an ArgumentException.
    if ((num & 1) == 1)
        throw gcnew ArgumentException(String::Format("{0} is not an even number", num), 
                                      "num");

    // num is even, return half of its value.
    return num / 2;
}

void main() 
{
    // Define some integers for a division operation.
    array<int>^ values = { 10, 7 };
    for each (int value in values) {
        try {
           Console::WriteLine("{0} divided by 2 is {1}", value, DivideByTwo(value));
        }
        catch (ArgumentException^ e) {
           Console::WriteLine("{0}: {1}", e->GetType()->Name, e->Message);
        }
        Console::WriteLine();
    }
}
// This example displays the following output:
//     10 divided by 2 is 5
//     
//     ArgumentException: 7 is not an even number
//     Parameter name: num
using System;

public class Example 
{
    static void Main() 
    {
        // Define some integers for a division operation.
        int[] values = { 10, 7 };
        foreach (var value in values) {
            try {
               Console.WriteLine("{0} divided by 2 is {1}", value, DivideByTwo(value));
            }
            catch (ArgumentException e) {
               Console.WriteLine("{0}: {1}", e.GetType().Name, e.Message);
            }
            Console.WriteLine();
        }
    }

    static int DivideByTwo(int num) 
    {
        // If num is an odd number, throw an ArgumentException.
        if ((num & 1) == 1)
            throw new ArgumentException(String.Format("{0} is not an even number", num), 
                                      "num");

        // num is even, return half of its value.
        return num / 2;
    }
}
// This example displays the following output:
//     10 divided by 2 is 5
//     
//     ArgumentException: 7 is not an even number
//     Parameter name: num
Public Class Example
    Public Shared Sub Main()
        ' Define some integers for a division operation.
        Dim values() As Integer = { 10, 7 }

        For Each value In values
            Try 
               Console.WriteLine("{0} divided by 2 is {1}", value, DivideByTwo(value))
            Catch e As ArgumentException
               Console.WriteLine("{0}: {1}", e.GetType().Name, e.Message)
            End Try
            Console.WriteLine()
        Next
    End Sub
    
    Private Shared Function DivideByTwo(ByVal num As Integer) As Integer
        ' If num is an odd number, throw an ArgumentException.
        If (num And 1) = 1 Then
            Throw New ArgumentException(String.Format("{0} is not an even number", num), 
                                      "num")
        End If
        Return num \ 2
    End Function
End Class
' The example displays the following output:
'     10 divided by 2 is 5
'     
'     ArgumentException: 7 is not an even number
'     Parameter name: num

Poznámky

ArgumentExceptionje vyvolána, když je vyvolána metoda a nejméně jeden z předaných argumentů nesplňuje specifikace parametru volané metody.ArgumentException is thrown when a method is invoked and at least one of the passed arguments does not meet the parameter specification of the called method. ParamName Vlastnost identifikuje neplatný argument.The ParamName property identifies the invalid argument.

ArgumentException Nejčastěji je vyvolána modulem CLR (Common Language Runtime) nebo jinou knihovnou tříd a označuje chybu vývojáře.Most commonly, an ArgumentException is thrown by the common language runtime or another class library and indicates developer error. Pokud vyvoláte ArgumentException z kódu, měli byste zajistit, aby Message vlastnost výjimky obsahovala smysluplnou chybovou zprávu, která popisuje neplatný argument a očekávaný rozsah hodnot argumentu.If you throw an ArgumentException from your code, you should ensure that the exception's Message property includes a meaningful error message that describes the invalid argument and the expected range of values for the argument.

Primární odvozené třídy třídy ArgumentException jsou ArgumentNullException a ArgumentOutOfRangeException.The primary derived classes of ArgumentException are ArgumentNullException and ArgumentOutOfRangeException. Tyto odvozené třídy by měly být použity namísto ArgumentException, s výjimkou případů, kdy není přijatelné ani jedna z odvozených tříd.These derived classes should be used instead of ArgumentException, except in situations where neither of the derived classes is acceptable. Například výjimky by měly být vyvolány pomocí:For example, exceptions should be thrown by:

  • ArgumentNullExceptionvždy null , když je předán metodě, která ji nepřijímá jako platný argument.ArgumentNullException whenever null is passed to a method that does not accept it as a valid argument.

  • ArgumentOutOfRangeExceptionKdyž hodnota argumentu je mimo rozsah přijatelných hodnot; Například pokud je hodnota "46" předána jako argument měsíc během vytváření DateTime.ArgumentOutOfRangeException when the value of an argument is outside the range of acceptable values; for example, when the value "46" is passed as the month argument during the creation of a DateTime.

Pokud volání metody nemá žádný argument nebo pokud selhání nezahrnuje samotné argumenty, InvalidOperationException je třeba použít.If the method call does not have any argument or if the failure does not involve the arguments themselves, then InvalidOperationException should be used.

ArgumentExceptionpoužívá HRESULT COR_E_ARGUMENT, který má hodnotu 0x80070057.ArgumentException uses the HRESULT COR_E_ARGUMENT, which has the value 0x80070057.

Seznam počáteční hodnoty vlastností pro instanci ArgumentException, najdete v článku ArgumentException konstruktory.For a list of initial property values for an instance of ArgumentException, see the ArgumentException constructors.

Konstruktory

ArgumentException() ArgumentException() ArgumentException() ArgumentException()

Inicializuje novou instanci třídy ArgumentException třídy.Initializes a new instance of the ArgumentException class.

ArgumentException(SerializationInfo, StreamingContext) ArgumentException(SerializationInfo, StreamingContext) ArgumentException(SerializationInfo, StreamingContext) ArgumentException(SerializationInfo, StreamingContext)

Inicializuje novou instanci třídy ArgumentException třídy se serializovanými daty.Initializes a new instance of the ArgumentException class with serialized data.

ArgumentException(String) ArgumentException(String) ArgumentException(String) ArgumentException(String)

Inicializuje novou instanci třídy ArgumentException třídy pomocí zadané chybové zprávy.Initializes a new instance of the ArgumentException class with a specified error message.

ArgumentException(String, Exception) ArgumentException(String, Exception) ArgumentException(String, Exception) ArgumentException(String, Exception)

Inicializuje novou instanci třídy ArgumentException třídy pomocí zadané chybové zprávy a odkazu na vnitřní výjimku, která je příčinou této výjimky.Initializes a new instance of the ArgumentException class with a specified error message and a reference to the inner exception that is the cause of this exception.

ArgumentException(String, String) ArgumentException(String, String) ArgumentException(String, String) ArgumentException(String, String)

Inicializuje novou instanci ArgumentException třídy se zadanou chybovou zprávou a názvem parametru, který tuto výjimku způsobuje.Initializes a new instance of the ArgumentException class with a specified error message and the name of the parameter that causes this exception.

ArgumentException(String, String, Exception) ArgumentException(String, String, Exception) ArgumentException(String, String, Exception) ArgumentException(String, String, Exception)

Inicializuje novou instanci ArgumentException třídy se zadanou chybovou zprávou, názvem parametru a odkazem na vnitřní výjimku, která je příčinou této výjimky.Initializes a new instance of the ArgumentException class with a specified error message, the parameter name, and a reference to the inner exception that is the cause of this exception.

Vlastnosti

Data Data Data Data

Získá kolekci párů klíč/hodnota, které poskytují další uživatelsky definované informace o výjimce.Gets a collection of key/value pairs that provide additional user-defined information about the exception.

(Inherited from Exception)
HelpLink HelpLink HelpLink HelpLink

Získá nebo nastaví odkaz na soubor s nápovědě spojený s touto výjimkou.Gets or sets a link to the help file associated with this exception.

(Inherited from Exception)
HResult HResult HResult HResult

Získá nebo nastaví hodnotu HRESULT, kódované číselné hodnoty, která je přiřazena konkrétní výjimce.Gets or sets HRESULT, a coded numerical value that is assigned to a specific exception.

(Inherited from Exception)
InnerException InnerException InnerException InnerException

Exception Získá instanci, která způsobila aktuální výjimku.Gets the Exception instance that caused the current exception.

(Inherited from Exception)
Message Message Message Message

Získá chybovou zprávu a název parametru, nebo pouze chybovou zprávu, pokud není nastaven žádný název parametru.Gets the error message and the parameter name, or only the error message if no parameter name is set.

ParamName ParamName ParamName ParamName

Získá název parametru, který tuto výjimku způsobuje.Gets the name of the parameter that causes this exception.

Source Source Source Source

Získá nebo nastaví název aplikace nebo objektu, který způsobuje chybu.Gets or sets the name of the application or the object that causes the error.

(Inherited from Exception)
StackTrace StackTrace StackTrace StackTrace

Načte řetězcovou reprezentaci okamžitých snímků v zásobníku volání.Gets a string representation of the immediate frames on the call stack.

(Inherited from Exception)
TargetSite TargetSite TargetSite TargetSite

Získá metodu, která vyvolá aktuální výjimku.Gets the method that throws the current exception.

(Inherited from Exception)

Metody

Equals(Object) Equals(Object) Equals(Object) Equals(Object)

Určuje, zda se zadaný objekt rovná aktuálnímu objektu.Determines whether the specified object is equal to the current object.

(Inherited from Object)
GetBaseException() GetBaseException() GetBaseException() GetBaseException()

Při přepsání v odvozené třídě vrátí hodnotu Exception , která je hlavní příčinou jedné nebo více následných výjimek.When overridden in a derived class, returns the Exception that is the root cause of one or more subsequent exceptions.

(Inherited from Exception)
GetHashCode() GetHashCode() GetHashCode() GetHashCode()

Slouží jako výchozí funkce hash.Serves as the default hash function.

(Inherited from Object)
GetObjectData(SerializationInfo, StreamingContext) GetObjectData(SerializationInfo, StreamingContext) GetObjectData(SerializationInfo, StreamingContext) GetObjectData(SerializationInfo, StreamingContext)

SerializationInfo Nastaví objekt s názvem parametru a dalšími informacemi o výjimce.Sets the SerializationInfo object with the parameter name and additional exception information.

GetType() GetType() GetType() GetType()

Získá typ modulu runtime aktuální instance.Gets the runtime type of the current instance.

(Inherited from Exception)
MemberwiseClone() MemberwiseClone() MemberwiseClone() MemberwiseClone()

Vytvoří kopii aktuálního Objectseznamu.Creates a shallow copy of the current Object.

(Inherited from Object)
ToString() ToString() ToString() ToString()

Vytvoří a vrátí řetězcovou reprezentaci aktuální výjimky.Creates and returns a string representation of the current exception.

(Inherited from Exception)

Události

SerializeObjectState SerializeObjectState SerializeObjectState SerializeObjectState

Nastane, pokud je serializovaná výjimka pro vytvoření objektu stavu výjimky, který obsahuje Serializovaná data o výjimce.Occurs when an exception is serialized to create an exception state object that contains serialized data about the exception.

(Inherited from Exception)

Platí pro

Viz také